=== debian/changelog ===
sdrangel (4.12.5-1) unstable; urgency=medium

  * Removed MIMO plugins and related code

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 01 Jan 2020 06:14:22 +0100

sdrangel (4.12.4-1) unstable; urgency=medium

  * Debian build: moved librtlsdr to external libraries

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Tue, 17 Dec 2019 19:14:22 +0100

sdrangel (4.12.3-1) unstable; urgency=medium

  * Added possibility to specify devices that cannot be discovered automatically
  * Server: fixed sink device set creation and added MIMO creation

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sun, 15 Dec 2019 23:14:22 +0100

sdrangel (4.12.2-1) unstable; urgency=medium

  * Refactoring of Rx channels code with better separation of concerns
  * ATV demod: complete refactoring
  * Channel Analyzer: refactoring of classes and downsampling chain reorganization
  * Remote Sink and Remote Output: refactoring of UDP blocks handling
  * NFMDemod: fixed setSelectedCtcssIndex method

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sat, 14 Dec 2019 06:14:22 +0100

sdrangel (4.12.1-1) unstable; urgency=medium

  * Tx plugins: further refactoring and fixes
  * Scope: added DOA projections and updated ChannelAnalzyer
  * Upgraded codec2 library to v0.9.2
  * NFM demod: fixed audio FIFO fill
  * Various changes to base classes for MIMO

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 19 Nov 2019 22:14:22 +0100

sdrangel (4.12.0-1) unstable; urgency=medium

  * Refactoring of Tx part with new FIFO and code reorganization
  * Corrected network manager process memory leaks
  * leansdr: fixes for macos

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Fri, 15 Nov 2019 00:14:22 +0100

sdrangel (4.11.12-1) unstable; urgency=medium

  * Test sink output plugin
  * ChannelAnalyzer: set trace length to FFT length  when auto-correlation by IFFT is used
  * Tx plugins: corrected FIFO begin iterator vs number of samples read
  * GLSpectrum: set default window to Hanning
  * More preparatory works for MIMO channels support

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Fri, 01 Nov 2019 14:14:22 +0100

sdrangel (4.11.11-1) unstable; urgency=medium

  * Channel Analyzer polar grid option for XY display (Issue #424)
  * Fixed MacOS build
  * More preparatory works for MIMO channels support

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 23 Oct 2019 20:14:22 +0200

sdrangel (4.11.10-1) unstable; urgency=medium

  * Plugins device enumeration optimization
  * Scope: added possibility to change trace chunk size
  * Upgraded to libbladerf 2019.07 release
  * Added a config.py API script to scriptsapi folder
  * Added sanity check in HackRF devices enumeration
  * Device engines: stop device before channels when going idle
  * Fixes to Flatpack build (PR #422)
  * More preparatory works for MIMO channels support

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 09 Oct 2019 05:14:22 +0200

sdrangel (4.11.9-1) unstable; urgency=medium

  * Fixed regression in v4.11.7 due to FIFO system
  * Upgraded SerialDV. Removed unused attribute in LocalSink GUI
  * Preparatory works for MIMO channels support

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sat, 10 Sep 2019 21:04:06 +0200

sdrangel (4.11.8-1) unstable; urgency=medium

  * HackRF: implemented transverter functionality
  * FreeDV demod: fixed spectrum span and channel id
  * RTL-SDR: RF bandwidth deserialization fix

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sat, 31 Aug 2019 06:04:06 +0200

sdrangel (4.11.7-1) unstable; urgency=medium

  * GLSpectrum and GLScope: fixed possible issues with mutex handling
  * Channel Analyzer: use FFTW engine with Hamming window for auto correlation
  * Package build: use DSDcc v1.8.6 to fix issue #406 with DSD decoder
  * Use a simplified version of sample FIFOs in the threaded baseband sample sink

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sat, 24 Aug 2019 06:04:06 +0200

sdrangel (4.11.6-1) unstable; urgency=medium

  * REST API /sdrange/config endpoint with GET, PUT, PATCH. Implements #241

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Mon, 12 Aug 2019 05:04:06 +0200

sdrangel (4.11.5-1) unstable; urgency=medium

  * CW keyer from keyboard. Audio monitor AM, NFM, SSB modulators. Implements #385

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Tue, 30 Jul 2019 23:04:06 +0200

sdrangel (4.11.4-1) unstable; urgency=medium

  * DATV demod: option to output transport stream to UDP. Implements #313

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sun, 28 Jul 2019 09:04:06 +0200

sdrangel (4.11.3-1) unstable; urgency=medium

  * PlutoSDR input: options for HW DC and IQ corrections. Implements #378
  * DATV demod: fix DVB-S FEC 7/8 not recognized from the GUI. Fixes #383
  * Fixed API request mapper validator not returning value in all cases. Fixes issue #386
  * Corrected endif in cpack/CMakeLists.txt. Fixes #377

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Thu, 25 Jul 2019 21:04:06 +0200

sdrangel (4.11.2-1) unstable; urgency=medium

  * New AMBE devices support including AMBE servers
  * Fixed closing main window with the corner X
  * Fixed some typos here and there
  * SSB mod: base audio compressor sample rate on audio sample rate

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Tue, 23 Jul 2019 21:04:06 +0200

sdrangel (4.11.1-1) unstable; urgency=medium

  * DATV demod: implemented DVB-S2 (experimental)
  * SSB modulator: use real audio compressor with just an on off toggle

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Thu, 18 Jul 2019 00:04:06 +0200

sdrangel (4.11.0-1) unstable; urgency=medium

  * File Source channel plugin
  * Flatpak build update

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Tue, 09 Jul 2019 23:04:06 +0200

sdrangel (4.10.5-1) unstable; urgency=medium

  * Windows: removed console display
  * Fixed REST API issues in some plugins

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Fri, 05 Jul 2019 20:04:06 +0200


